Last Comment Bug 516422 - [HTML5][Patch] Link Prefetch test fails in Browserscope Network Test (regression)
: [HTML5][Patch] Link Prefetch test fails in Browserscope Network Test (regress...
Status: RESOLVED FIXED
:
Product: Core
Classification: Components
Component: HTML: Parser (show other bugs)
: unspecified
: x86 Windows XP
: P1 normal (vote)
: ---
Assigned To: Henri Sivonen (:hsivonen)
:
Mentors:
http://www.browserscope.org/network/test
Depends on:
Blocks: html5-parsing
  Show dependency treegraph
 
Reported: 2009-09-14 08:17 PDT by Stebs
Modified: 2010-04-16 01:25 PDT (History)
5 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments
Copy and paste the relevent code from nsHTMLContentSink (2.21 KB, patch)
2010-02-24 06:38 PST, Henri Sivonen (:hsivonen)
mozilla+ben: review+
Details | Diff | Review

Description Stebs 2009-09-14 08:17:21 PDT
User-Agent:       Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.3a1pre) Gecko/20090913 Minefield/3.7a1pre
Build Identifier: 

Parallel Scripts, CSS + Inline Script and Link Prefetch tests fail when html5 parser is enabled.
This is probably (partially) a dupe of  Bug 482919?
...not sure about it though, especially with Link Prefetch, hence this Bug. 

Reproducible: Always

Steps to Reproduce:
1.set html5.enable;true
2.run Test on url provided above

Actual Results:  
3 Tests fail (8/11)

Expected Results:  
with html5.enable;false, all Tests succeed (11/11)
Comment 1 Stebs 2009-11-27 04:58:44 PST
Now parallel scripts and parallel CSS + Inline script tests are sucessfull on trunk, probably because Bug 482919 got fixed.
On Namoroka these tests still fail (Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.2b5pre) Gecko/20091126 Namoroka/3.6b5pre)

Network test regression on trunk with html5 enabled left is Link Prefetch, editing Bug Title accordingly.
Comment 2 Henri Sivonen (:hsivonen) 2009-11-27 06:18:17 PST
(In reply to comment #1)
> Now parallel scripts and parallel CSS + Inline script tests are sucessfull on
> trunk, probably because Bug 482919 got fixed.
> On Namoroka these tests still fail (Mozilla/5.0 (Windows; U; Windows NT 5.1;
> en-US; rv:1.9.2b5pre) Gecko/20091126 Namoroka/3.6b5pre)

The HTML5 parser is abandoned on the 3.6 branch.

> Network test regression on trunk with html5 enabled left is Link Prefetch,
> editing Bug Title accordingly.

Thanks for catching this!
Comment 3 Henri Sivonen (:hsivonen) 2010-02-24 06:38:39 PST
Created attachment 428708 [details] [diff] [review]
Copy and paste the relevent code from nsHTMLContentSink
Comment 4 Ben Newman (:bnewman) (:benjamn) 2010-02-24 15:01:11 PST
Comment on attachment 428708 [details] [diff] [review]
Copy and paste the relevent code from nsHTMLContentSink

Well copied/pasted!
Comment 5 Henri Sivonen (:hsivonen) 2010-02-26 01:49:43 PST
http://hg.mozilla.org/mozilla-central/rev/a63b18f1d4d0
Comment 6 d 2010-04-15 04:05:21 PDT
Excuse me for entering this "fixed" bug, but the main issue doesn't seem to be resolved. The Browserscope test still fails for me, and also: http://browserspy.dk/prefetch.php. Has it regressed again, or was it never really fixed?
Comment 7 Henri Sivonen (:hsivonen) 2010-04-15 04:56:14 PDT
I'm pretty sure I really fixed this with http://hg.mozilla.org/mozilla-central/rev/a63b18f1d4d0 . I guess this has regressed again. :-(
Comment 8 Stebs 2010-04-15 05:49:44 PDT
Yes, it was (is) definitely fixed, and for me the Browserscope Network Test #14: Link Prefetch still works (both with html5 enabled and disabled)!
Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.3a5pre) Gecko/20100414 Minefield/3.7a5pre

The test ist not very reliable though and sometimes fails (I guess because it seems to measure how fast something is loading, which naturally can go wrong).
Once all tests are run through, you can click on the 14 to retry only this test.
When I opened this Bug, the test failed, no matter how often you retried the test.

Browserspy test always fails here, maybe a problem on their side?

I'm astonished that such network functionality is not tested in any of the numerous automated tests that mozilla does nowadays, maybe because those tests are hard to do/verify automatically?
Comment 9 d 2010-04-15 06:16:27 PDT
Here's the source of the first prefetch test:

"<!doctype html>
<html>
<head>
<title>Performance Link Prefetch Test</title>


</head>

<body>

<h1>Link Prefetch (1 of 2)</h1>

<script>
window.onload = function() {
    // in Firefox, prefetched resources are downloaded sequentially (!!)
    setTimeout(gotoNextPage, 15000);
}

function gotoNextPage() {
	parent.testframe.location = "link-prefetch2?t=1271337151";
}
</script>

<p>
prefetching some resources...

<p>
<link rel="prefetch" href="http://1.cuzillion.com/bin/resource.cgi?type=gif&sleep=4&prefetch=1&t=1271337151">
<link rel="prefetch" href="http://1.cuzillion.com/bin/resource.cgi?type=css&sleep=4&prefetch=1&t=1271337151">
<link rel="prefetch" href="http://2.cuzillion.com/bin/resource.cgi?type=js&sleep=4&prefetch=1&t=1271337151">





</body>

</html>"

Not very pretty code, I'd say, but perhaps there's clues to why this is unreliable, in there?
Comment 10 Henri Sivonen (:hsivonen) 2010-04-15 06:33:10 PDT
I rebuilt from rev a63b18f1d4d0 to verify that this bug was indeed fixed by the landing until it regressed again.
Comment 11 d 2010-04-15 06:38:41 PDT
(In reply to comment #10)
> I rebuilt from rev a63b18f1d4d0 to verify that this bug was indeed fixed by the
> landing until it regressed again.

It would be nice if we could narrow down a regression range, but unfortunately I am not experienced enough to build Firefox/Minefield myself.
Comment 12 Henri Sivonen (:hsivonen) 2010-04-15 06:48:18 PDT
(In reply to comment #8)
> I'm astonished that such network functionality is not tested in any of the
> numerous automated tests that mozilla does nowadays, maybe because those tests
> are hard to do/verify automatically?

It wouldn't have matter anyway, because tinderboxen don't run with the HTML5 parser enabled.

(In reply to comment #11)
> It would be nice if we could narrow down a regression range, but unfortunately
> I am not experienced enough to build Firefox/Minefield myself.

Indeed, a regression window would help a lot. I don't see any landings touching this code in an obvious way.
Comment 13 Henri Sivonen (:hsivonen) 2010-04-15 23:53:45 PDT
I'm locating the regression window now.
Comment 14 Henri Sivonen (:hsivonen) 2010-04-16 00:46:56 PDT
Marking FIXED again. This has to have been a transient server-side problem. Retesting today shows that link prefetching works.
Comment 15 d 2010-04-16 01:25:03 PDT
You're right. The browserspy test (http://browserspy.dk/prefetch.php) also passes now. A bit odd, but sure, it's good news in the end.

"Your browser support prefetch.

Your browser sent the required X-Moz header.

Your browser sent the following referer header: http://browserspy.dk/prefetch.php"

Note You need to log in before you can comment on or make changes to this bug.